//******************************************************************************
//  
//      PWM_SW.C
//
//
//      CONTROLE DE POTENCIA CARGA CC (METODO  PWM)
//
//      Utiliza 2 chaves dactilares para controle.
//      Frequncia PWM de 1khz
//
//      Autor: Cludio Lrios
//      Data: 04/11/2014
//
//      Este arquivo  parte integrante do blog "LRIOS.TECNOLOGIA.WS'.
//      Obs. apenas para fins didticos.
//

//      PINAGENS:
//      pino 1 - +5v
//      pino 2 - chave dactilar ao gnd
//      pino 3 - chave dactilar ao gnd
//      pino 4 - desligado
//      pino 5 - sada pwm a um resistor de 470 a base do transistor npn. Emissor
//               ao gnd e coletor a carga a ser controlada (conforme corrente).
//      pino 6 - desligado
//      pino 7 - desligado
//
//==============================================================================


#include <12F675.h>
#device adc=8
#use delay(clock=4000000)// OSC INTERNO DE 4MHZ
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, PUT, BROWNOUT //CONFIG WORD

//bytes

#byte gpio       = 0x05
#byte trisio     = 0x85
#byte tmr0       = 0x01
#byte wpu        = 0x95
#bit  gwpu       = 0x81.7 //geral pullups

#bit   out       = 0x5.2 //saida pwm
#bit   sw_up     = 0x5.4 //sw aumenta percentual ligado
#bit   sw_dw     = 0x5.5 //sw reduz   percentual ligado

//VARIVEIS GLOBAIS

int8 cont,pwm,passo;

const int8 velocidade = 20; //tempo de 5 segundos para ir do 0 a 100% na sada

#int_timer0
void tmr_isr(){//GERA PWM NA SAIDA
   if(!passo){
    pwm=cont;
    tmr0=~pwm;
    passo++;
    if(pwm==2){ out=0;}else {out=1;}
    }
    else
   {
    tmr0=pwm;
    passo=0;
    if(pwm==254) {out=1;} else{out=0;}  
   }
}

//==============================================================================
//           CONFIGURAES
//==============================================================================

void main() {

   setup_adc_ports(NO_ANALOGS|VSS_VDD);//DESLIGA COMPARADORES
   setup_adc(ADC_OFF);
   setup_counters(RTCC_INTERNAL,RTCC_DIV_4);//TIMER 0
   setup_timer_1(T1_DISABLED); //DESABILITA TIMER 1
   setup_vref(FALSE);//DESLIGA VREF
   setup_comparator(NC_NC_NC_NC);//DESLIGA COMPARADORES
   wpu=0b110000;//pullup
   gpio=0;//ZERA GPIO
   trisio= 0b111011; //ACERTA DIREO DOS PORTS
   passo=0;
   gwpu=0;//geral dos pullups
   enable_interrupts(GLOBAL);//liga geral das interrupes
   enable_interrupts(INT_TIMER0);//liga interrupo do tmr0
//==============================================================================
//    INICIO DO PROGRAMA
//==============================================================================

   for(;;){//LOOP INFINITO
    
    if(!sw_up){ if(++cont==255)cont--; //testa chave de incremento
    }
     if(!sw_dw){ if(--cont==1)cont++; //testa chave de decremento
    }
    delay_ms(velocidade);//velocidade de incrementos/decrementos
   }
}
